option explicit

' Delete Wallpaper script for Windows 7
' -------------------------------------
' v1.00
' 18/Aug/2009
' Leo Davidson <leo@ox.compsoc.net> http://www.pretentiousname.com
' Tested on Windows 7 RTM x64
'
' This script is intended to be installed on your Desktop context menu to provide
' an easy way to delete the current wallpaper using the recycle bin. It's most
' likely to be useful for people who use Windows 7's wallpaper slideshow feature
' as it lets you delete images you don't like when the cycle around.

const HKEY_CURRENT_USER = &H80000001

Dim WShell
Set WShell = CreateObject("WScript.Shell")

Dim AShell
Set AShell = CreateObject("Shell.Application")

Dim FileSys
Set FileSys = CreateObject("Scripting.FileSystemObject") 

' Find the file which the current wallpaper comes from.

Dim FilePath
FilePath = WShell.RegRead("HKEY_CURRENT_USER\Software\Microsoft\Internet Explorer\Desktop\General\WallpaperSource")

If TypeName(FilePath) <> "String" Then
	MsgBox WScript.ScriptName & " Error: WallpaperSource in the registry is not a string path."
	WScript.Quit 1
End If

' Split it into path and name

Dim FolderPath
Dim FileName
FolderPath = FileSys.GetParentFolderName(FilePath)
FileName = FileSys.GetFileName(FilePath)

If FolderPath = "" Or FileName = "" Then
	MsgBox WScript.ScriptName & " Error: WallpaperSource in the registry is an invalid path."
	WScript.Quit 1
End If

' Bind to the shell object for the file

Dim FolderObj
Set FolderObj = AShell.NameSpace(FolderPath)

If FolderObj Is Nothing Then
	MsgBox WScript.ScriptName & ": The wallpaper source folder does not exist."
	WScript.Quit 1
End If

Dim FileObj
Set FileObj = FolderObj.ParseName(FileName)

If FileObj Is Nothing Then
	MsgBox WScript.ScriptName & ": The wallpaper source file does not exist."
	WScript.Quit 1
End If

' Delete the file.
' (We could have deleted it a lot easier using the FileSys object but doing it
' using the shell instead means we use the recycle bin and display a nice
' confirmation message with a thumbnail and other details. That way the user
' is unlikely to delete the wrong wallpaper by mistake and can restore the file
' if they change their mind.)

FileObj.InvokeVerb("delete")
